给定一个整数数组 nums 和一个目标值 target,请你在该数组中找出和为目标值的那 两个 整数,并返回他们的数组下标。
你可以假设每种输入只会对应一个答案。但是,你不能重复利用这个数组中同样的元素。
示例:
给定 nums = [2, 7, 11, 15], target = 9
因为 nums[0] + nums[1] = 2 + 7 = 9
所以返回 [0, 1]
来源:力扣(LeetCode)
链接:https://leetcode-cn.com/problems/two-sum
算法一:暴力枚举
算法二:哈希表存储优化暴力循环第二维,我们可以将数存在哈希表里面而不用去循环找,而是直接由哈希表查找,是o1的复杂度,
class Solution {
public:
vector<int> twoSum(vector<int>& nums, int target) {
vector<int> res;
unordered_map<int,int> hash;
for(int i=0;i<nums.size();++i){
int now = target-nums[i];
if(hash.count(now)){
res.push_back(hash[now]);
res.push_back(i);
break;
}
hash[nums[i]]=i;
}
return res;
}
};